unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FPCanvas, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
  private
    FBitmap: TBitmap;

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  LRandomColor: Integer;
begin
  //if assigned(FBitmap) then freeandnil(FBitmap); //Hier gehts nicht
  LRandomColor := Random($FFFFFF);
  FBitmap := TBitmap.Create;
  FBitmap.SetSize(20,20);
  FBitmap.Canvas.Brush.Color:=clWhite;
  FBitmap.Canvas.FillRect(0,0,width,height);
  FBitmap.Canvas.Brush.Color:=LRandomColor;
  FBitmap.Canvas.Ellipse(5,5,15,15);


  Invalidate;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  FBitmap := nil;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 if assigned(FBitmap) then freeandnil(FBitmap);
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  if not Assigned(FBitmap) then Exit;
  Canvas.Brush.Bitmap := nil;
  //Canvas.Brush.Style := bsSolid;  kein Unterschied
  //canvas.Brush.Style := bsImage;  kein Unterschied
  Canvas.Brush.Bitmap := FBitmap ;
  Canvas.FillRect(0, 0, ClientWidth, ClientHeight) ;
  if assigned(FBitmap) then freeandnil(FBitmap);   //hier gehts
end;

end.

